SystemOrganization addCategory: #'QC-Seaside-Tests'!

WAComponent subclass: #TAddressView
	instanceVariableNames: 'addressComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QC-Seaside-Tests'!

!TAddressView methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/27/2012 11:49'!
addressComponent
	^ addressComponent! !

!TAddressView methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/27/2012 11:49'!
addressComponent: anObject
	addressComponent := anObject! !

!TAddressView methodsFor: 'as yet unclassified' stamp: 'FriedrichDominicus 4/27/2012 11:43'!
children
	^ Array with: addressComponent.! !

!TAddressView methodsFor: 'as yet unclassified' stamp: 'FriedrichDominicus 4/27/2012 21:26'!
initialize 
	| result | 
	result := super initialize.
      result 	addressComponent:TAddress testAddress asComponent.
	^ result! !

WAComponent subclass: #TPersonView
	instanceVariableNames: 'person'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QC-Seaside-Tests'!

!TPersonView methodsFor: 'as yet unclassified' stamp: 'FriedrichDominicus 4/27/2012 15:31'!
canBeRoot 
	^ true.! !

!TPersonView methodsFor: 'as yet unclassified' stamp: 'FriedrichDominicus 4/27/2012 15:32'!
children
	^ Array with: person.! !

!TPersonView methodsFor: 'as yet unclassified' stamp: 'FriedrichDominicus 4/27/2012 21:26'!
initialize 
	| result | 
	result := super initialize.
      result 	person: TPerson testPerson asComponent.
	^ result! !

!TPersonView methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/27/2012 15:31'!
person
	^ person! !

!TPersonView methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/27/2012 15:31'!
person: anObject
	person := anObject! !

WAComponent subclass: #TPersonsOverview
	instanceVariableNames: 'persons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QC-Seaside-Tests'!

!TPersonsOverview class methodsFor: 'as yet unclassified' stamp: 'FriedrichDominicus 5/5/2012 07:03'!
canBeRoot 
	^ true.! !

!TPersonsOverview methodsFor: 'as yet unclassified' stamp: 'FriedrichDominicus 5/5/2012 07:03'!
children
	^ Array with: persons.! !

!TPersonsOverview methodsFor: 'as yet unclassified' stamp: 'FriedrichDominicus 5/5/2012 07:05'!
initialize 
	| result | 
	result := super initialize.
      result persons: TPersons new asComponent .
	^ result! !

!TPersonsOverview methodsFor: 'accessing' stamp: 'FriedrichDominicus 5/5/2012 07:06'!
persons
	^ persons! !

!TPersonsOverview methodsFor: 'accessing' stamp: 'FriedrichDominicus 5/5/2012 07:06'!
persons: anObject
	persons := anObject! !

Object subclass: #TAddress
	instanceVariableNames: 'id zip city street belongsTo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QC-Seaside-Tests'!

!TAddress class methodsFor: 'as yet unclassified' stamp: 'FriedrichDominicus 4/27/2012 11:39'!
testAddress
	| result |
	result := self new.
	result zip: '76646';
		street:  'Kraichgaustr 11';
		city: 'Bruchsal'.
	^ result.! !

!TAddress methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/26/2012 14:59'!
belongsTo
	^ belongsTo! !

!TAddress methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/26/2012 14:59'!
belongsTo: anObject
	belongsTo := anObject! !

!TAddress methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/26/2012 14:54'!
city
	^ city! !

!TAddress methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/26/2012 14:54'!
city: anObject
	city := anObject! !

!TAddress methodsFor: 'access-descriptions' stamp: 'FriedrichDominicus 4/27/2012 11:41'!
descriptionCity
	<magritteDescription>
	^ MAStringDescription new
		accessor: #city;
		label: 'City';
		priority: 200;
		yourself! !

!TAddress methodsFor: 'access-descriptions' stamp: 'FriedrichDominicus 4/27/2012 11:41'!
descriptionStreet
	<magritteDescription>
	^ MAStringDescription new
		accessor: #street;
		label: 'Street';
		priority: 250;
		yourself! !

!TAddress methodsFor: 'access-descriptions' stamp: 'FriedrichDominicus 4/27/2012 11:40'!
descriptionZip
	<magritteDescription>
	^ MAStringDescription new
		accessor: #zip;
		label: 'Zip';
		priority: 150;
		yourself! !

!TAddress methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/26/2012 14:54'!
id
	^ id! !

!TAddress methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/26/2012 14:54'!
id: anObject
	id := anObject! !

!TAddress methodsFor: 'as yet unclassified' stamp: 'FriedrichDominicus 5/5/2012 07:30'!
optionsAndLabelsForm
	| result |
	result := self -> self shortPrintForm.
	 ^ result.! !

!TAddress methodsFor: 'as yet unclassified' stamp: 'FriedrichDominicus 5/5/2012 07:21'!
shortPrintForm
	| result |
	result :=  self zip, ' ', self city, '; ', self street.
	^ result.! !

!TAddress methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/26/2012 14:54'!
street
	^ street! !

!TAddress methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/26/2012 14:54'!
street: anObject
	street := anObject! !

!TAddress methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/26/2012 14:54'!
zip
	^ zip! !

!TAddress methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/26/2012 14:54'!
zip: anObject
	zip := anObject! !

Object subclass: #TDatabase
	instanceVariableNames: 'persons addresses phoneNumbers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QC-Seaside-Tests'!

TDatabase class
	instanceVariableNames: 'root persons'!

TDatabase class
	instanceVariableNames: 'root persons'!

!TDatabase class methodsFor: 'as yet unclassified' stamp: 'FriedrichDominicus 4/27/2012 21:26'!
root
	root ifNil: [ root := self new ].
	^ root.! !

!TDatabase class methodsFor: 'as yet unclassified' stamp: 'FriedrichDominicus 4/26/2012 14:58'!
root: aNewRoot
	root := aNewRoot.! !

!TDatabase class methodsFor: 'as yet unclassified' stamp: 'FriedrichDominicus 5/4/2012 15:17'!
testPersons
	| person address phoneNumber somePersons|
	person := TPerson new.
	person firstName:'Friedrich'.
	person surName:  'Dominicus'.
	address := TAddress new.
	address zip: '76646';
	city: 'Bruchsal';
	street: 'KStreet 11'.
	person addAddress: address.
	somePersons  := OrderedCollection new.
	somePersons add: person.
	person := TPerson new.
	person firstName: 'FName';
		surName: 'SName'.
	address := address copy.
	address street: 'SesamStreet'.
	person addAddress: address.
	somePersons add:  person.
	self root persons: somePersons.! !

!TDatabase methodsFor: 'accessing' stamp: 'FriedrichDominicus 5/4/2012 15:16'!
addresses
	^ addresses ifNil: [addresses := OrderedCollection new ]! !

!TDatabase methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/26/2012 14:56'!
addresses: anObject
	addresses := anObject! !

!TDatabase methodsFor: 'accessing' stamp: 'FriedrichDominicus 5/4/2012 15:07'!
persons
	^ persons ifNil: [persons := OrderedCollection new].! !

!TDatabase methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/26/2012 14:56'!
persons: anObject
	persons := anObject! !

!TDatabase methodsFor: 'accessing' stamp: 'FriedrichDominicus 5/4/2012 15:08'!
phoneNumbers
	^ phoneNumbers ifNil: [phoneNumbers := OrderedCollection new.]! !

!TDatabase methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/26/2012 14:56'!
phoneNumbers: anObject
	phoneNumbers := anObject! !

Object subclass: #TPerson
	instanceVariableNames: 'surName firstName addresses phoneNumbers buildOptionsAndLabelsForAddresses optionsAndLabelsForAddresses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QC-Seaside-Tests'!

!TPerson class methodsFor: 'as yet unclassified' stamp: 'FriedrichDominicus 4/27/2012 15:27'!
testPerson
	| result | 
	result := self new.
	result firstName: 'Friedrich'.
	result surName: 'Dominicus'.
	result addresses:  result class twoAddressesCollection.
	^ result ! !

!TPerson class methodsFor: 'as yet unclassified' stamp: 'FriedrichDominicus 4/27/2012 20:32'!
twoAddressesCollection

	| col anAddress | 
	col := OrderedCollection new.
	anAddress := TAddress new.
	anAddress zip: '1111';
	       city: 'city 1';
		 street: 'street 1'.
	col add: anAddress.
	anAddress := TAddress new.
	anAddress zip: '2222';
	       city: 'city 2';
		 street: 'street 2'.
	col add: anAddress.
	^ col. 
	! !

!TPerson methodsFor: 'adding/removing' stamp: 'FriedrichDominicus 4/26/2012 15:03'!
addAddress: aTAddress
	self addresses add: aTAddress.
	" this code  should be not written here, don't mess with others peoples data. So better would be to announce that something new was added"
	TDatabase root addresses add: aTAddress.! !

!TPerson methodsFor: 'accessing' stamp: 'FriedrichDominicus 5/4/2012 15:15'!
addresses
	^ addresses ifNil: [addresses:= OrderedCollection new].! !

!TPerson methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/26/2012 14:52'!
addresses: anObject
	addresses := anObject! !

!TPerson methodsFor: 'accessing' stamp: 'FriedrichDominicus 5/5/2012 07:33'!
buildOptionsAndLabelsForAddresses
	optionsAndLabelsForAddresses := OrderedCollection new.
	self addresses do: [:each | 
			optionsAndLabelsForAddresses add: each optionsAndLabelsForm. ].
		
		
	! !

!TPerson methodsFor: 'accessing' stamp: 'FriedrichDominicus 5/5/2012 07:16'!
buildOptionsAndLabelsForAddresses1
	^ buildOptionsAndLabelsForAddresses! !

!TPerson methodsFor: 'accessing' stamp: 'FriedrichDominicus 5/5/2012 07:16'!
buildOptionsAndLabelsForAddresses: anObject
	buildOptionsAndLabelsForAddresses := anObject! !

!TPerson methodsFor: 'as yet unclassified' stamp: 'FriedrichDominicus 5/5/2012 07:13'!
descriptionAddresses
	<magritteDescription>
	self buildOptionsAndLabelsForAddresses.
	^ MASingleOptionDescription new
        accessor: #addresses;
        label: 'Addresses' ; 
        priority: 400;
	  optionsAndLabels: self optionsAndLabelsForAddresses;
        options: self addresses
	yourself
! !

!TPerson methodsFor: 'as yet unclassified' stamp: 'FriedrichDominicus 4/27/2012 15:21'!
descriptionFirstName
	<magritteDescription>
	^ MAStringDescription new
		accessor: #firstName;
		label: 'First Name';
		priority: 150;
		yourself! !

!TPerson methodsFor: 'as yet unclassified' stamp: 'FriedrichDominicus 4/27/2012 15:21'!
descriptionSurName
	<magritteDescription>
	^ MAStringDescription new
		accessor: #surName;
		label: 'Sur Name';
		priority: 100;
		yourself! !

!TPerson methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/26/2012 14:52'!
firstName
	^ firstName! !

!TPerson methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/26/2012 14:52'!
firstName: anObject
	firstName := anObject! !

!TPerson methodsFor: 'accessing' stamp: 'FriedrichDominicus 5/5/2012 07:21'!
optionsAndLabelsForAddresses
	^ optionsAndLabelsForAddresses! !

!TPerson methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/26/2012 14:52'!
phoneNumbers
	^ phoneNumbers! !

!TPerson methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/26/2012 14:52'!
phoneNumbers: anObject
	phoneNumbers := anObject! !

!TPerson methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/27/2012 15:26'!
surName
	^ surName! !

!TPerson methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/27/2012 15:26'!
surName: anObject
	surName := anObject! !

Object subclass: #TPersons
	instanceVariableNames: 'persons'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QC-Seaside-Tests'!

!TPersons methodsFor: 'as yet unclassified' stamp: 'FriedrichDominicus 5/5/2012 07:36'!
descriptionPersons
	<magritteDescription>
	^ MAToManyRelationDescription new
		priority: 50;
		label: 'Persons';
		accessor: #persons;
		classes: {TPerson};
		comment: 'All persons';
		yourself! !

!TPersons methodsFor: 'accessing' stamp: 'FriedrichDominicus 5/5/2012 06:59'!
persons
	persons := TDatabase root persons.
	^ persons.! !

!TPersons methodsFor: 'accessing' stamp: 'FriedrichDominicus 5/5/2012 06:59'!
persons: anObject
	persons := anObject! !

Object subclass: #TPhoneNumber
	instanceVariableNames: 'id tag number belongsTo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QC-Seaside-Tests'!

!TPhoneNumber methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/26/2012 14:59'!
belongsTo
	^ belongsTo! !

!TPhoneNumber methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/26/2012 14:59'!
belongsTo: anObject
	belongsTo := anObject! !

!TPhoneNumber methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/26/2012 14:55'!
id
	^ id! !

!TPhoneNumber methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/26/2012 14:55'!
id: anObject
	id := anObject! !

!TPhoneNumber methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/26/2012 14:55'!
number
	^ number! !

!TPhoneNumber methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/26/2012 14:55'!
number: anObject
	number := anObject! !

!TPhoneNumber methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/26/2012 14:55'!
tag
	^ tag! !

!TPhoneNumber methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/26/2012 14:55'!
tag: anObject
	tag := anObject! !

Object subclass: #TWithMagritte
	instanceVariableNames: 'surName firstName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'QC-Seaside-Tests'!

!TWithMagritte methodsFor: 'magritte-description' stamp: 'FriedrichDominicus 4/26/2012 16:27'!
descriptionFirstName
	<magritteDescription>
	^ MAStringDescription new
		accessor: #firstName;
		label: 'First Name';
		priority: 150;
		yourself! !

!TWithMagritte methodsFor: 'magritte-description' stamp: 'FriedrichDominicus 4/26/2012 16:27'!
descriptionSurName
	<magritteDescription>
	^ MAStringDescription new
		accessor: #surName;
		label: 'Sur Name';
		priority: 100;
		yourself! !

!TWithMagritte methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/26/2012 15:09'!
firstName
	^ firstName! !

!TWithMagritte methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/26/2012 15:09'!
firstName: anObject
	firstName := anObject! !

!TWithMagritte methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/26/2012 15:09'!
surName
	^ surName! !

!TWithMagritte methodsFor: 'accessing' stamp: 'FriedrichDominicus 4/26/2012 15:09'!
surName: anObject
	surName := anObject! !
